// This file is generated by Forward_h.template.

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef v8_inspector_protocol_Forward_h
#define v8_inspector_protocol_Forward_h

#include "src/inspector/string-util.h"

#include <cstddef>
#include <memory>
#include <vector>
#include <unordered_map>
#include <unordered_set>

#include "../../deps/v8/third_party/inspector_protocol/bindings/bindings.h"

namespace v8_inspector {
namespace protocol {

class DictionaryValue;
class DispatchResponse;
class ErrorSupport;
class FundamentalValue;
class ListValue;
class Object;
using Response = DispatchResponse;
class SerializedValue;
class StringValue;
class UberDispatcher;
class Value;

namespace detail {
template <typename T>
struct ArrayTypedef { typedef std::vector<std::unique_ptr<T>> type; };

template <>
struct ArrayTypedef<String> { typedef std::vector<String> type; };

template <>
struct ArrayTypedef<int> { typedef std::vector<int> type; };

template <>
struct ArrayTypedef<double> { typedef std::vector<double> type; };

template <>
struct ArrayTypedef<bool> { typedef std::vector<bool> type; };
}  // namespace detail

template <typename T>
using Array = typename detail::ArrayTypedef<T>::type;

namespace detail {
using v8_inspector_protocol_bindings::glue::detail::PtrMaybe;
using v8_inspector_protocol_bindings::glue::detail::ValueMaybe;

template <typename T>
struct MaybeTypedef { typedef PtrMaybe<T> type; };

template <>
struct MaybeTypedef<bool> { typedef ValueMaybe<bool> type; };

template <>
struct MaybeTypedef<int> { typedef ValueMaybe<int> type; };

template <>
struct MaybeTypedef<double> { typedef ValueMaybe<double> type; };

template <>
struct MaybeTypedef<String> { typedef ValueMaybe<String> type; };

template <>
struct MaybeTypedef<Binary> { typedef ValueMaybe<Binary> type; };
}  // namespace detail

template <typename T>
using Maybe = typename detail::MaybeTypedef<T>::type;

} // namespace v8_inspector
} // namespace protocol

#endif // !defined(v8_inspector_protocol_Forward_h)


// This file is generated by FrontendChannel_h.template.

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef v8_inspector_protocol_FrontendChannel_h
#define v8_inspector_protocol_FrontendChannel_h

namespace v8_inspector {
namespace protocol {

class  Serializable {
public:
    ProtocolMessage serialize(bool binary) {
      if (binary)
        return StringUtil::binaryToMessage(serializeToBinary());
      else
        return StringUtil::jsonToMessage(serializeToJSON());
    }
    virtual String serializeToJSON() = 0;
    virtual std::vector<uint8_t> serializeToBinary() = 0;
    virtual ~Serializable() = default;
};

class  FrontendChannel {
public:
    virtual ~FrontendChannel() { }
    virtual void sendProtocolResponse(int callId, std::unique_ptr<Serializable> message) = 0;
    virtual void sendProtocolNotification(std::unique_ptr<Serializable> message) = 0;
    virtual void fallThrough(int callId, const String& method, const ProtocolMessage& message) = 0;
    virtual void flushProtocolNotifications() = 0;
};

} // namespace v8_inspector
} // namespace protocol

#endif // !defined(v8_inspector_protocol_FrontendChannel_h)
